//UnbenutzteFormate_204d.js
// 11.05.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Unbenutzte Formate werden gelscht

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// die Programmversion feststellen
var appVers = app.version[0];
if (appVers != 4) {
	if (appVers == 5) {
		alert ("Fr InDesign CS3\nbitte die entsprechende Version des Scripts benutzen.", "Achtung");
	}
	else if (appVers == 6) {
		alert ("Fr InDesign CS4\nbitte die entsprechende Version des Scripts benutzen.", "Achtung");
	}
	else {
		alert ("Dieses Script nur mit InDesign CS2 benutzen.", "Achtung");
	}
	exit();
}

// Variablen initialisieren
var curDoc = app.documents[0];
var noParaStyle = curDoc.paragraphStyles[0].name;
var dfParaStyle = curDoc.paragraphStyles[1].name;
var noCharStyle = curDoc.characterStyles[0].name;
var cCtr = 0;
var pCtr = 0;

// die Liste der Absatzformate, welche als "Basiert auf" und/oder 
// "Nchstes Format" eingetragen sind, erstellen
var allParaStyles = curDoc.paragraphStyles;
var allParaNames = allParaStyles.everyItem().name;
var nParaStyles = allParaStyles.length;
var inUsePNames = new Array ();
var curProps, curNameP, bas, nxt;
for (var i=1; i<nParaStyles; i++) {
	curProps = allParaStyles[i].properties;
	curNameP = curProps.name;
	try {
		bas = curProps.basedOn.name;
		if (bas != undefined && bas != dfParaStyle) {
			if (!isInArray(bas, inUsePNames)) {
				inUsePNames.push(bas);
			}
		}
	}
	catch (e) {
	}
	try {
		nxt = curProps.nextStyle.name;
		if (nxt != undefined && nxt != curNameP && nxt != dfParaStyle) {
			if (!isInArray(nxt, inUsePNames)) {
				inUsePNames.push(nxt);
			}
		}
	}
	catch (e) {
	}
}

// in Objektstilen verwendete Absatzformate einbeziehen
var allObjectStyles = curDoc.objectStyles;
var nObjStyles = allObjectStyles.length;
var obj;
for (var i=0; i<nObjStyles; i++) {
	try {
		obj = allObjectStyles[i].appliedParagraphStyle.name;
		if (obj != undefined && obj != noParaStyle && obj != dfParaStyle) {
			if (!isInArray(obj, inUsePNames)) {
				inUsePNames.push(obj);
			}
		}
	}
	catch (e) {
	}
}

// auch die Namen der im Dokument verwendeten Absatzformate 
// an die Liste anhngen
var allStories = curDoc.stories;
var nStories = allStories.length;
var allStyles, nStyles;
for (var i=0; i<nStories; i++) {
	if (allStories[i].length >0) {
		try {
			allStyles = allStories[i].paragraphs.everyItem().appliedParagraphStyle;
			nStyles = allStyles.length;
			for (var s=0; s<nStyles; s++) {
				curName = allStyles[s].name;
				if (curName != noParaStyle && curName != dfParaStyle) {
					if (!isInArray(curName, inUsePNames)) {
						inUsePNames.push(curName);
					}
				}
			}
		}
		catch (e) {
		}
	}
	else {
		try {
			curName = allStories[i].insertionPoints[0].appliedParagraphStyle.name;
			if (curName != noParaStyle && curName != dfParaStyle) {
				if (!isInArray(curName, inUsePNames)) {
					inUsePNames.push(curName);
				}
			}
		}
		catch (e) {
		}
	}
}

// Absatzformate, welche in Tabellen verwendet werden
try {
	var tabPStyles = allStories.everyItem().tables.everyItem().cells.everyItem().texts[0].paragraphs.everyItem().appliedParagraphStyle;
	nStyles = tabPStyles.length;
	for (var t=0; t<nStyles; t++) {
		curName = tabPStyles[t].name;
		if (curName != noParaStyle && curName != dfParaStyle) {
			if (!isInArray(curName, inUsePNames)) {
				inUsePNames.push(curName);
			}
		}
	}
}
catch (e) {
}

// Absatzformate, welche in Fussnoten verwendet werden
try {
	var footPStyles = allStories.everyItem().footnotes.everyItem().texts[0].paragraphs.everyItem().appliedParagraphStyle;
	nStyles = footPStyles.length;
	for (var f=0; f<nStyles; f++) {
		curName = footPStyles[f].name;
		if (curName != noParaStyle && curName != dfParaStyle) {
			if (!isInArray(curName, inUsePNames)) {
				inUsePNames.push(curName);
			}
		}
	}
}
catch (e) {
}

// eine Schleife durch die Absatzformatliste; Format lschen, 
// wenn es sich nicht in der Liste "verwendet" befindet
for (var i=nParaStyles-1; i>1; i--) {
	curName = allParaNames[i];
	if (!isInArray(curName, inUsePNames)) {
		try {
			curDoc.paragraphStyles[i].remove();
			pCtr++;
		}
		catch (e) {
		}
	}
}

// die Liste der Zeichenformate, welche als "Basiert auf" 
// eingetragen sind, erstellen
var allCharStyles = curDoc.characterStyles;
var allCharNames = allCharStyles.everyItem().name;
var nCharStyles = allCharNames.length;
var inUseCNames = new Array ();
for (var i=1; i<nCharStyles; i++) {
	try {
		bas = allCharStyles[i].properties.basedOn.name;
		if (bas != undefined && bas != noCharStyle) {
			if (!isInArray(bas, inUseCNames)) {
				inUseCNames.push(bas);
			}
		}
	}
	catch (e) {
	}
}

// die Zeichenformate, welche als Hngende Initialen und/oder 
// in verschachtelten Formaten verwendet werden, anhngen
var allParaStyles = curDoc.paragraphStyles;
var nParaStyles = allParaStyles.length;
var nes;
for (var d=1; d<nParaStyles; d++) {
	nes = allParaStyles[d].nestedStyles;
	nStyles = nes.length;
	for (var n=0; n<nStyles; n++) {
		curName = nes[n].appliedCharacterStyle.name;
		if (curName != noCharStyle) {
			if (!isInArray(curName, inUseCNames)) {
				inUseCNames.push(curName);
			}
		}
	}
}

// die im Dokument verwendeten Zeichenformate an die Liste anhngen
for (var i=0; i<nStories; i++) {
	if (allStories[i].length >0) {
		try {
			allStyles = allStories[i].textStyleRanges.everyItem().appliedCharacterStyle;
			nStyles = allStyles.length;
			for (var s=0; s<nStyles; s++) {
				curName = allStyles[s].name;
				if (curName != noCharStyle) {
					if (!isInArray(curName, inUseCNames)) {
						inUseCNames.push(curName);
					}
				}
			}
		}
		catch (e) {
		}
	}
	else {
		try {
			curName = allStories[i].insertionPoints[0].appliedCharacterStyle.name;
			if (curName != noCharStyle) {
				if (!isInArray(curName, inUseCNames)) {
					inUseCNames.push(curName);
				}
			}
		}
		catch (e) {
		}
	}
}

// Zeichenformate, welche in Tabellen verwendet werden
try {
	var tabCStyles = allStories.everyItem().tables.everyItem().cells.everyItem().texts[0].textStyleRanges.everyItem().appliedCharacterStyle;
	nStyles = tabCStyles.length;
	for (var c=0; c<nStyles; c++) {
		curName = tabCStyles[c].name;
		if (curName != noCharStyle) {
			if (!isInArray(curName, inUseCNames)) {
				inUseCNames.push(curName);
			}
		}
	}
}
catch (e) {
}

// Zeichenformate, welche in Fussnoten verwendet werden
try {
	var footCStyles = allStories.everyItem().footnotes.everyItem().texts[0].textStyleRanges.everyItem().appliedCharacterStyle;
	nStyles = footCStyles.length;
	for (var c=0; c<nStyles; c++) {
		curName = footCStyles[c].name;
		if (curName != noCharStyle) {
			if (!isInArray(curName, inUseCNames)) {
				inUseCNames.push(curName);
			}
		}
	}
}
catch (e) {
}

// eine Schleife durch die Zeichenformatliste; Format lschen, 
// wenn es sich nicht in der Liste "verwendet" befindet
for (var i=nCharStyles-1; i>0; i--) {
	curName = allCharNames[i];
	if (!isInArray(curName, inUseCNames)) {
		try {
			curDoc.characterStyles[i].remove();
			cCtr++;
		}
		catch (e) {
		}
	}
}

// den Anwender informieren
var totCtr = pCtr + cCtr;
if (totCtr == 0) {
	alert ("Keine Formate gelscht.", "Fertig");
}
else {
	if (totCtr == 1) {
		if (pCtr == 1) {
			alert ("Ein Absatzformat gelscht.", "Fertig");
		}
		else {
			alert ("Ein Zeichenformat gelscht.", "Fertig");
		}
	}
	else {
		alert ("Gelschte Formate:\t" + totCtr + "\n\nAbsatzformate:\t" + pCtr + "\nZeichenformate:\t" + cCtr, "Fertig");
	}
}

// der Handler, welcher prft, ob sich das aktuelle Element schon in der Liste befindet
function isInArray(curName, curArray) {
	for (var a=0; a<curArray.length; a++) {
		if(curArray[a] == curName) {
			return true;
		}
	}
	return false;
}